﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Threading;
using System.Data;

namespace StressAdHocTVP{
	class Program {
		static int counter = 0;
		static void Main( string[] args ) {
			try {
				SqlConnectionStringBuilder cs = new SqlConnectionStringBuilder();
				cs.DataSource = @".";
				cs.InitialCatalog = "swarttest";
				cs.IntegratedSecurity = true;
				cs.AsynchronousProcessing = true;
				string connectionString = cs.ToString();
				string sql = @"SELECT Value FROM @MyParameter;";
				// build table
				DataTable dt = new DataTable();
				dt.Columns.Add( "i", typeof( long ) );
				foreach( long l in new long[] { 1, 2, 3, 4, 5, 6, 7 } )
				    dt.LoadDataRow( new object[] { l }, true );

				for( int i = 0; i < 1000; i++ ) {
					SqlConnection conn = new SqlConnection( connectionString );
					conn.Open();
					SqlCommand cmd = new SqlCommand( sql, conn );
					cmd.CommandType = System.Data.CommandType.Text;
					cmd.CommandTimeout = 5000;
					SqlParameter tvpParam = cmd.Parameters.AddWithValue( "@MyParameter", dt );
					tvpParam.SqlDbType = SqlDbType.Structured;
					tvpParam.TypeName = "dbo.BigIntSet";
					cmd.BeginExecuteNonQuery( new AsyncCallback( EndExecution ), cmd );
				}
				Console.WriteLine( string.Format( @"Error count: {0}", counter ) );
			} catch( Exception ex ) {
				Console.WriteLine( ex.Message );
			} 
		}

		static void EndExecution( IAsyncResult c ) {
			SqlCommand endCmd = ( c.AsyncState as SqlCommand );
			try {
				endCmd.EndExecuteNonQuery( c );
			} catch( Exception ex ) {
				//counter++;
				Interlocked.Increment( ref counter );
				Console.WriteLine( ex.Message );
			} finally {
				endCmd.Connection.Close();
			}
		}
	}
}