﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Threading;
using System.Data;

namespace StressXMLShred {
	class Program {
		static int counter = 0;
		static void Main( string[] args ) {
			try {
				SqlConnectionStringBuilder cs = new SqlConnectionStringBuilder();
				cs.DataSource = @".";
				cs.InitialCatalog = "swarttest";
				cs.IntegratedSecurity = true;
				cs.AsynchronousProcessing = true;
				string connectionString = cs.ToString();
				string sql = @"
					SELECT L.Value.value( '.', 'bigint' )
					FROM @MyParameter.nodes( 'root/value' ) AS L(Value);";
				string value = "<root><value>1</value><value>2</value><value>3</value><value>4</value><value>5</value><value>6</value><value>7</value></root>";
				
				for( int i = 0; i < 1000; i++ ) {
					SqlConnection conn = new SqlConnection( connectionString );
					conn.Open();
					SqlCommand cmd = new SqlCommand( sql, conn );
					cmd.CommandType = System.Data.CommandType.Text;
					cmd.CommandTimeout = 5000;
					SqlParameter tvpParam = cmd.Parameters.AddWithValue( "@MyParameter", value );
					tvpParam.SqlDbType = SqlDbType.Xml;
					cmd.BeginExecuteNonQuery( new AsyncCallback( EndExecution ), cmd );
				}
				Console.WriteLine( string.Format( @"Error count: {0}", counter ) );
			} catch( Exception ex ) {
				Console.WriteLine( ex.Message );
			}
		}

		static void EndExecution( IAsyncResult c ) {
			SqlCommand endCmd = ( c.AsyncState as SqlCommand );
			try {
				endCmd.EndExecuteNonQuery( c );
			} catch( Exception ex ) {
				//counter++;
				Interlocked.Increment( ref counter );
				Console.WriteLine( ex.Message );
			} finally {
				endCmd.Connection.Close();
			}
		}
	}
}